dnsMessage
send(dnsMessage query) throws IOException {
	byte [] out, in;
	dnsMessage response;
	DatagramSocket s;
	DatagramPacket dp;

	try {
		s = new DatagramSocket();
	}
	catch (SocketException e) {
		System.out.println(e);
		return null;
	}

	if (useEDNS)
		query.addRecord(dns.ADDITIONAL, dnsEDNS.newOPT(1280));

	if (TSIG != null)
		TSIG.apply(query);


	out = query.toWire();

	if (useTCP)
		return sendTCP(query, out);

	s.send(new DatagramPacket(out, out.length, addr, port));

	dp = new DatagramPacket(new byte[512], 512);
	s.setSoTimeout(timeoutValue);
	try {
		s.receive(dp);
	}
	catch (InterruptedIOException e) {
		s.close();
		System.out.println(";; No response");
		return null;
	}
	in = new byte [dp.getLength()];
	System.arraycopy(dp.getData(), 0, in, 0, in.length);
	response = new dnsMessage(in);
	if (TSIG != null) {
		boolean ok = TSIG.verify(response, in, query.getTSIG());
		System.out.println(";; TSIG verify: " + ok);
	}

	s.close();
	if (response.getHeader().getFlag(dns.TC))
		return sendTCP(query, out);
	else
		return response;
}
