dnsMessage
generateReply(dnsMessage query) {
	Enumeration qds = query.getSection(dns.QUESTION);
	dnsRecord queryRecord = (dnsRecord) qds.nextElement();

	dnsMessage response = new dnsMessage();
	response.getHeader().setID(query.getHeader().getID());
	response.getHeader().setFlag(dns.AA);
	response.addRecord(dns.QUESTION, queryRecord);

	dnsName name = queryRecord.getName();
	dnsZone zone = findBestZone(name);
	if (zone == null) {
		response.getHeader().setRcode(dns.SERVFAIL);
	}
	else {
		Vector responseRecords = zone.findName(name);
		if (responseRecords == null) {
			response.getHeader().setRcode(dns.NXDOMAIN);
		}
		else {
			int added = 0;
			Enumeration e = responseRecords.elements();
			while (e.hasMoreElements()) {
				dnsRecord r = (dnsRecord) e.nextElement();
				if (r.getType() == queryRecord.getType() &&
				    r.getDClass() == queryRecord.getDClass())
				{
					response.addRecord(dns.ANSWER, r);
					added++;
				}
			}
		}
	}
	return response;
}
