dnsMessage
sendAXFR(dnsMessage query) throws IOException {
	byte [] out, in;
	Socket s;
	int inLength;
	DataInputStream dataIn;
	int soacount = 0;
	dnsMessage response;
	boolean first = true;

	try {
		s = new Socket(addr, port);
	}
	catch (SocketException e) {
		System.out.println(e);
		return null;
	}

	if (TSIG != null)
		TSIG.apply(query);

	out = query.toWire();
	new DataOutputStream(s.getOutputStream()).writeShort(out.length);
	s.getOutputStream().write(out);
	s.setSoTimeout(timeoutValue);

	response = new dnsMessage();
	response.getHeader().setID(query.getHeader().getID());
	if (TSIG != null)
		TSIG.verifyAXFRStart();
	while (soacount < 2) {
		try {
			dataIn = new DataInputStream(s.getInputStream());
			inLength = dataIn.readUnsignedShort();
			in = new byte[inLength];
			dataIn.readFully(in);
		}
		catch (InterruptedIOException e) {
			s.close();
			System.out.println(";; No response");
			return null;
		}
		dnsMessage m = new dnsMessage(in);
		if (m.getHeader().getCount(dns.QUESTION) != 0 ||
		    m.getHeader().getCount(dns.ANSWER) <= 0 ||
		    m.getHeader().getCount(dns.AUTHORITY) != 0)
		{
			StringBuffer sb = new StringBuffer();
			sb.append("Invalid AXFR: ");
			for (int i=0; i < 4; i++) {
				Enumeration e = m.getSection(i);
				System.out.println("--");
				while (e.hasMoreElements()) {
					dnsRecord r;
					r = (dnsRecord)e.nextElement();
					System.out.println(r);
				}
				System.out.println();
			}
			System.out.println(sb.toString());
			s.close();
			return null;
		}
		for (int i = 1; i < 4; i++) {
			Enumeration e = m.getSection(i);
			while (e.hasMoreElements()) {
				dnsRecord r = (dnsRecord)e.nextElement();
				response.addRecord(i, r);
				if (r instanceof dnsSOARecord)
					soacount++;
			}
		}
		if (TSIG != null) {
			boolean required = (soacount > 1 || first);
			boolean ok = TSIG.verifyAXFR(m, in, query.getTSIG(),
						     required, first);
			System.out.println("TSIG verify: " + ok);
		}
		first = false;
	}

	s.close();
	return response;
}
