Message
generateReply(Message query) {
	Enumeration qds = query.getSection(dns.QUESTION);
	Record queryRecord = (Record) qds.nextElement();

	Message response = new Message();
	response.getHeader().setID(query.getHeader().getID());
	response.getHeader().setFlag(dns.AA);
	response.addRecord(dns.QUESTION, queryRecord);

	Name name = queryRecord.getName();
	Zone zone = findBestZone(name);
	if (zone == null) {
		response.getHeader().setRcode(dns.SERVFAIL);
	}
	else {
		Vector responseRecords = zone.findName(name);
		if (responseRecords == null) {
			response.getHeader().setRcode(dns.NXDOMAIN);
		}
		else {
			int added = 0;
			Enumeration e = responseRecords.elements();
			while (e.hasMoreElements()) {
				Record r = (Record) e.nextElement();
				if (r.getType() == queryRecord.getType() &&
				    r.getDClass() == queryRecord.getDClass())
				{
					response.addRecord(dns.ANSWER, r);
					added++;
				}
			}
		}
	}
	return response;
}
